/* -*- mode: c++; c-basic-offset: 4; -*- */
#ifndef STD_LCL_ARRAY_HH
#define STD_LCL_ARRAY_HH

/**  Local array template definition
  */
template<class T>
class lcl_array {
public:
    typedef unsigned long size_type;
private:
    T* _data;
public:
    lcl_array(size_type _n) {_data = new T[_n];}
    ~lcl_array(void) {delete [] _data;}
    operator T* (void) {return _data;}
    operator const T* (void) const {return _data;}
    T* get(void) {return _data;}
    const T* get(void) const {return _data;}
private:
    lcl_array(const lcl_array&);
    lcl_array& operator=(const lcl_array&);
};

#endif   // !defined(STD_LCL_ARRAY_HH)
