#ifndef SWAPFRAME_HH
#define SWAPFRAME_HH

class SwapFrame {
public:
  SwapFrame(void);
  ~SwapFrame(void);
  void Swap(char* p, int len);

private:
  enum wType {
    kNone = 0,
    kChar,
    kString,
    kShort,
    kInt,
    kDouble,
    kPtr
  };

  void SwapString(int N=1);
  void SwapShort(int N=1);
  void SwapInt(int N=1);
  void SwapDouble(int N=1);
  short SwapHdr(void);
  bool procFileHdr(void);
  void procSH(void);
  void procSE(void);
  void procVect(void);
  void Bump(int nBytes) {mPtr += nBytes; mLeft -= nBytes;}

#define MAXID     32
#define MAXTABLE 128

private:
  bool  mBigEnd;    // byte ordering of the present machine.
  char* mPtr;
  int   mLeft;
  int*  mTable[MAXID];
  int   mLastID;
  int   mVectID;
};

#endif // SWAPFRAME_HH
